

/*
 * Include Files
 *
 */
#if defined(MATLAB_MEX_FILE)
#include "tmwtypes.h"
#include "simstruc_types.h"
#else
#include "rtwtypes.h"
#endif

/* %%%-SFUNWIZ_wrapper_includes_Changes_BEGIN --- EDIT HERE TO _END */
#ifndef MATLAB_MEX_FILE
#include <arduino.h>
#include "Wire.h"
#include "Wire.cpp"
#include "twi.h"
#include "twi.c"
#include <SPI.h>
#include <SPI.cpp>
#define HYT_ADDR1 0x28     // I2C address of the HYT 221, 271, 371 and most likely the rest of the family
#define HYT_ADDR2 0x29
#endif
/* %%%-SFUNWIZ_wrapper_includes_Changes_END --- EDIT HERE TO _BEGIN */
#define y_width 1
/*
 * Create external references here.  
 *
 */
/* %%%-SFUNWIZ_wrapper_externs_Changes_BEGIN --- EDIT HERE TO _END */
/* extern double func(double a); */
/* %%%-SFUNWIZ_wrapper_externs_Changes_END --- EDIT HERE TO _BEGIN */

/*
 * Output functions
 *
 */
extern "C" void sfLect_Capteurs_Outputs_wrapper(real_T *temp_thermo,
			real_T *hum1,
			real_T *temp1,
			real_T *hum2,
			real_T *temp2,
			real_T *pression,
			const real_T *xD,
			const uint8_T  *pin, const int_T  p_width0,
			const uint8_T  *analogpin, const int_T  p_width1,
			const uint8_T  *HYT221_add1, const int_T  p_width2,
			const uint8_T  *HYT221_add2, const int_T  p_width3)
{
/* %%%-SFUNWIZ_wrapper_Outputs_Changes_BEGIN --- EDIT HERE TO _END */
if (xD[0]==1){
    #ifndef MATLAB_MEX_FILE
      int receivedVal16,val16;
      double temp;
      
      Wire.beginTransmission(HYT221_add1[0]);   // Begin transmission with given device on I2C bus
      Wire.endTransmission(); 
      Wire.beginTransmission(HYT221_add2[0]);   // Begin transmission with given device on I2C bus
      Wire.endTransmission(); 
      delay(100);
      Wire.requestFrom(HYT221_add1[0], 4);      // Request 4 bytes 
  
      // Read the bytes if they are available
      // The first two bytes are humidity the last two are temperature
      if(Wire.available() == 4) {                   
        int b1 = Wire.read();
        int b2 = Wire.read();
        int b3 = Wire.read();
        int b4 = Wire.read();
    
    // combine humidity bytes and calculate humidity
        int rawHumidity = b1 << 8 | b2;
    // compound bitwise to get 14 bit measurement first two bits
    // are status/stall bit (see intro text)
        rawHumidity =  (rawHumidity &= 0x3FFF);
        hum1[0] = 100.0 / pow(2,14) * rawHumidity;
    
    // combine temperature bytes and calculate temperature
        b4 = (b4 >> 2); // Mask away 2 least significant bits see HYT 221 doc
        int rawTemperature = b3 << 6 | b4;
        temp1[0] = 165.0 / pow(2,14) * rawTemperature - 40;
    
    }
    else {
        temp1[0]=0;
        hum1[0]=0;
    }

    Wire.requestFrom(HYT221_add2[0], 4);      // Request 4 bytes 
  
  // Read the bytes if they are available
  // The first two bytes are humidity the last two are temperature
    if(Wire.available() == 4) {                   
        int b1 = Wire.read();
        int b2 = Wire.read();
        int b3 = Wire.read();
        int b4 = Wire.read();
    
    // combine humidity bytes and calculate humidity
        int rawHumidity = b1 << 8 | b2;
    // compound bitwise to get 14 bit measurement first two bits
    // are status/stall bit (see intro text)
        rawHumidity =  (rawHumidity &= 0x3FFF);
        hum2[0] = 100.0 / pow(2,14) * rawHumidity;
    
    // combine temperature bytes and calculate temperature
        b4 = (b4 >> 2); // Mask away 2 least significant bits see HYT 221 doc
        int rawTemperature = b3 << 6 | b4;
        temp2[0] = 165.0 / pow(2,14) * rawTemperature - 40;
    }
    else {
        temp2[0]=0;
        hum2[0]=0;
    }
      
      
      digitalWrite(pin[0],LOW);
      receivedVal16 = SPI.transfer16(val16);
      SPI.transfer16(val16);
      digitalWrite(pin[0],HIGH);
      receivedVal16=receivedVal16>>2;
      temp_thermo[0]=receivedVal16/4.;
      
      int conv=analogRead(analogpin[0]);
      pression[0]=conv*4.887*50.+10000.;
    #endif
}
/* %%%-SFUNWIZ_wrapper_Outputs_Changes_END --- EDIT HERE TO _BEGIN */
}

/*
  * Updates function
  *
  */
extern "C" void sfLect_Capteurs_Update_wrapper(real_T *temp_thermo,
			real_T *hum1,
			real_T *temp1,
			real_T *hum2,
			real_T *temp2,
			real_T *pression,
			real_T *xD,
			const uint8_T  *pin,  const int_T  p_width0,
			const uint8_T  *analogpin,  const int_T  p_width1,
			const uint8_T  *HYT221_add1,  const int_T  p_width2,
			const uint8_T  *HYT221_add2,  const int_T  p_width3)
{
  /* %%%-SFUNWIZ_wrapper_Update_Changes_BEGIN --- EDIT HERE TO _END */
/*
 * Code example
 *   xD[0] = u0[0];
*/
if (xD[0]!=1){
    #ifndef MATLAB_MEX_FILE
    pinMode(9, OUTPUT);
    digitalWrite(9,HIGH);
    delay(10);
    pinMode(pin[0], OUTPUT);
    digitalWrite(pin[0],LOW);
    digitalWrite(pin[0],HIGH);
    Wire.begin(); 
    // initialize SPI:
    SPI.begin();
    SPI.beginTransaction(SPISettings(2000000, MSBFIRST, SPI_MODE1));
    #endif
    xD[0]=1;
}
/* %%%-SFUNWIZ_wrapper_Update_Changes_END --- EDIT HERE TO _BEGIN */
}
